.\" Copyright (C) 2001 Information-technology Promotion Agency (IPA)
.\" Copyright (C) 2001-2011
.\"   National Institute of Advanced Industrial Science and Technology (AIST)
.\" This file is part of the m17n library documentation.
.\" Permission is granted to copy, distribute and/or modify this document
.\" under the terms of the GNU Free Documentation License, Version 1.2 or
.\" any later version published by the Free Software Foundation; with no
.\" Invariant Section, no Front-Cover Texts,
.\" and no Back-Cover Texts.  A copy of the license is included in the
.\" appendix entitled "GNU Free Documentation License".
.TH "mdbFontset" 5 "12 Jan 2011" "Version 1.6.2" "The m17n Library" \" -*- nroff -*-
.ad l
.nh
.SH NAME
mdbFontset \- Fontset 
.SH "DESCRIPTION"
.PP
The m17n library loads a fontset definition from the m17n database by the tags <fontset, FONTSET\-NAME>. The plist format of the data is as follows:
.PP
.PP
.nf

FONTSET ::= PER\-SCRIPT * PER\-CHARSET * FALLBACK *

PER\-SCRIPT ::= '(' SCRIPT PER\-LANGUAGE + ')'

PER\-LANGUAGE ::= '(' LANGUAGE FONT\-SPEC\-ELEMENT + ')'

PER\-CHARSET ::= '(' CHARSET FONT\-SPEC\-ELEMENT + ')'

FALLBACK ::= FONT\-SPEC\-ELEMENT

FONT\-SPEC\-ELEMENT ::= '(' FONT\-SPEC [ FLT\-NAME ] ')'

FONT\-SPEC ::=
     '(' [ FOUNDRY FAMILY
           [ WEIGHT [ STYLE [ STRETCH [ ADSTYLE ]]]]]
         REGISTRY
	 [ OTF\-SPEC ] [ LANG\-SPEC ] ')'
.fi
.PP
.PP
\fCSCRIPT\fP is a symbol of script name (e.g. latin, han) or \fCnil\fP. \fCLANGUAGE\fP is a two\-letter symbol of language name code defined by ISO 639 (e.g. ja, zh) or \fCnil\fP.
.PP
\fCFONT\-SPEC\fP is to specify properties of a font. \fCFOUNDRY\fP to \fCREGISTRY\fP are symbols corresponding to Mfoundry to Mregistry property of a font. See \fBm17nFont\fP for the meaning of each property.
.PP
\fCOTF\-SPEC\fP is a symbol specifyng the required OTF features. The symbol name has the following syntax.
.PP
.PP
.nf

  OTF\-SPEC\-NAME ::= ':otf=' SCRIPT LANGSYS ? GSUB\-FEATURES ? GPOS\-FEATURES ?

  SCRIPT ::= SYMBOL
  LANGSYS ::= '/' SYMBOL

  GSUB\-FEATURES ::= '=' FEATURE\-LIST ?

  GPOS\-FEATURES ::= '+' FEATURE\-LIST ?

  FEATURE\-LIST ::= '~' ? FEATURE ( ',' '~' ? FEATURE ',' )

.fi
.PP
.PP
Here, \fCFEATURE\fP is a four\-letter Open Type feature.
.PP
\fCLANG\-SPEC\fP is a symbol specifying the required language support. The symbol name has the following syntax.
.PP
.PP
.nf

  LANG\-SPEC\-NAME ::= ':lang=' LANG
.fi
.PP
.PP
Here, \fCLANG\fP is a two or three\-letter ISO\-639 language code.
.PP
\fCFLT\-NAME\fP is a name of Font Layout Table (\fBFont Layout Table\fP).
.SH "EXAMPLE"
.PP
This is an example of \fCPER_SCRIPT\fP.
.PP
.PP
.nf

(han
  (ja
    ((jisx0208.1983\-0)))
  (zh
    ((gb2312.1980\-0)))
  (nil
    ((big5\-0))))
.fi
.PP
.PP
It instructs the font selector to use a font of registry 'jisx0208.1983\-0' for a 'han' character (i.e. a character whose Mscript property is 'han') if the character has Mlanguage text property 'ja' in an M\-text and the character is in the repertories of such fonts. Otherwise, try a font of registry 'gb2312.1980\-0' or 'big5\-0'. If that 'han' character does not have Mlanguage text property, try all three fonts.
.PP
See the function mdraw_text() for the detail of how a font is selected. 
.SH COPYRIGHT
Copyright (C) 2001 Information\-technology Promotion Agency (IPA)
.br
Copyright (C) 2001\-2011 National Institute of Advanced Industrial Science and Technology (AIST)
.br
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License 
<http://www.gnu.org/licenses/fdl.html>.
